﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Composite
{
	class Directory : Node
	{
		private List<Node> children = new List<Node>();

		public Directory(string name)
		{
			Name = name;
		}

		public override void Display()
		{
			Console.WriteLine($"DIR: {Name}");
			foreach (Node comp in children)
			{
				comp.Display();
			}
		}

		public void AddChildren(Node child)
		{
			if (child != null)
				children.Add(child);
		}
	}
}
