﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Facade
{
	/*
	 * 카테고리: 구조 패턴
	 * 개요: 복잡하고 커다란 서브시스템을 간단한 인터페이스를 통해 사용이 쉽도록 함
	 * 클라이언트는 패턴을 통해 전면의 단순 인터페이스만 사용하므로,
	 * 서브시스템 라이브러리 사용의 가독성, 사용도를 높임
	 * 
	 * 참고: Adapter 패턴과 유사하지만,
	 * Adapter는 클라이언트가 필요로 하는 다른 인터페이스로 변환하는 것이고
	 * Facade는 서브시스템을 쉽게 사용할 수 있는 간단한 인터페이스를 제공하는 것임
	 */
	class Program
	{
		static void Main(string[] args)
		{
			Client.HowToUse();

			Console.ReadKey();
		}
	}
}
