﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Template
{
    // 베이스클래스
    internal abstract class Letter
    {
        public void Send()
        {
            CompanyLogo();
            Greeting();

            Message();
            Offer();

            Ending();
            Footer();
        }

        // 필수
        public abstract void Message();

        // 옵션
        public virtual void Offer() { }


        // 고정 메서드 들
        private void CompanyLogo()
        {
            Console.WriteLine("COMPANY LOGO");
        }

        private void Greeting()
        {
            Console.WriteLine("HELLO");
        }

        private void Ending()
        {
            Console.WriteLine("BYE");
        }

        private void Footer()
        {
            Console.WriteLine("WARM REGARD");
        }
    }
}
